︠758c7310-c43f-48c5-abf1-94ee3b56a2da︠
#Lab 1: Plotting legs (a,b) of Primitive Pythagorean Triples
reset
︡ac8d192d-6438-447c-8e1c-914fe334ac74︡{"stdout":"<function reset at 0x7f3837eaf050>\n"}︡{"done":true}
︠c659d795-37b6-4033-8979-5bed71c55edcs︠
#1. The function makes a list of pairs [m,n] of rationals m/n from N diagonals of the table of rationals
#//Input:?
#//Output:?
def mn_pairs(N):
    L=[];
    for n in range(2,N+2):
        temp=[[m,n] for m in range(1,n)]
        L.extend(temp)
    return L
︡fccbc813-dae3-4dfd-b270-088bfd853c5f︡{"done":true}
︠06993967-1eec-4f5d-8667-43d6c43d25ffs︠
#Example
L=mn_pairs(10);L
︡219c1deb-6310-4669-b00c-e938b541ce63︡{"stdout":"[[1, 2], [1, 3], [2, 3], [1, 4], [2, 4], [3, 4], [1, 5], [2, 5], [3, 5], [4, 5], [1, 6], [2, 6], [3, 6], [4, 6], [5, 6], [1, 7], [2, 7], [3, 7], [4, 7], [5, 7], [6, 7], [1, 8], [2, 8], [3, 8], [4, 8], [5, 8], [6, 8], [7, 8], [1, 9], [2, 9], [3, 9], [4, 9], [5, 9], [6, 9], [7, 9], [8, 9], [1, 10], [2, 10], [3, 10], [4, 10], [5, 10], [6, 10], [7, 10], [8, 10], [9, 10], [1, 11], [2, 11], [3, 11], [4, 11], [5, 11], [6, 11], [7, 11], [8, 11], [9, 11], [10, 11]]\n"}︡{"done":true}
︠47f309d2-5d8e-4286-83d6-6db0c539af19︠
# 2.The function makes a list of legs [a,b] of PTs and excludes PTs that are not primitive (i.e., pairs with a and b are not mutuallly prime)
#//Input:
#//Output:number of PTs in L,number of PPT in L,list of PPTs
def ppt_legs(L):
    p_triples=[[c[1]^2-c[0]^2,2*c[0]*c[1]] for c in L ]#list of PTs
    pp_triples=[t for t in p_triples if gcd(t[0],t[1]) == 1]#list of PPTs
    return(len(p_triples),len(pp_triples),pp_triples)

︡900bf1b2-4a45-42bf-a4da-f1d5dae10e54︡
︠5a2a15bf-114a-4f62-8492-872f5cc2ae7c︠
#Example continued
︡a497b012-922a-4d82-a804-15155782e658︡
︠883d1f1e-7c30-43ba-a7a7-9a729357e68es︠
n_pt,n_ppt,S=ppt_legs(L);n_pt #Convenient way to get multiple output
︡41678b66-44ce-4d50-856e-6be7de723b64︡{"stdout":"55\n"}︡{"done":true}
︠e0b0bcb5-d666-481e-95e1-50e74624814fs︠
n_ppt
︡0a30f47d-9eef-4cac-852e-53586e850401︡{"stdout":"27\n"}︡{"done":true}
︠71b9f897-e526-4e13-a0d5-08026256afd1s︠
#Example of plotting points in SageMath
point(S,size=30,color='red',figsize=[4,3])
︡93eb4210-0fa7-4078-b99d-6108ad726f79︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/1427/tmp_K2qdsj.svg","show":true,"text":null,"uuid":"ef42d67c-ab6d-4239-8175-850d01b20365"},"once":false}︡{"done":true}
︠f1a33a58-7fe0-44fa-b930-d9eea4b0ebaas︠
#3. Main code
#//Input: Number of diagonals in the table of rationals
#//Output:?
def plot_ppt(N):
    L=mn_pairs(N)
    n_pt,n_ppt,S=ppt_legs(L)
    G=point(S,size=30,color='red',figsize=[5,4])
    G.show()
    return("Number of PTs:", n_pt, "Number of PTs:",n_ppt)


︡af390d30-202f-4e74-8ee0-72f3ed820c44︡{"done":true}
︠e418c81b-29b1-4979-96f7-456147c6b897s︠
plot_ppt(20)
︡6fef3654-b43c-4efe-abff-3e94dfa0df31︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/1427/tmp_662IPz.svg","show":true,"text":null,"uuid":"f88c9c87-09d9-4f41-be61-78fb1a5738c8"},"once":false}︡{"stdout":"('Number of PTs:', 210, 'Number of PTs:', 92)"}︡{"stdout":"\n"}︡{"done":true}
︠10d394cf-a1e1-4aa6-8234-20994110d78ds︠
#Example of alternative plotting points in S using Python libraries
# Get data for plotting points
x=[s[0] for s in S];y=[s[1] for s in S]
︡bef7bcfa-e05d-4b1f-aa7c-07de71d64809︡{"done":true}
︠69db0d52-3dc3-4ae9-bdaa-a8567ac40abas︠
import matplotlib.pyplot as plt
from matplotlib.pyplot import figure
figure(num=None, figsize=(5, 3))
figure=plt.plot(x, y,'ro',markersize=4)
plt.show(figure)
︡78f13b52-4a50-4358-911f-f62e27933230︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/1427/tmp_ulZbGS.svg","show":true,"text":null,"uuid":"b6b8d474-58f2-4b49-8dbc-66e5b5c1c4bb"},"once":false}︡{"file":{"filename":"d4dd7d87-9de0-479c-8bea-ba4c9fed9d3d.svg","show":true,"text":null,"uuid":"be47b1e6-5b66-4229-bfac-63c7872010da"},"once":false}︡{"done":true}
︠e7085fda-0dec-4522-b849-9afbf65dad9ds︠
#Advanced nice snippet of code for plotting (just FYI)
import numpy as np
import matplotlib.pyplot as plt

#evenly sampled time at 200ms intervals
t = np.arange(0., 5., 0.2)

# red dashes, blue squares and green triangles
plt.plot(t, t, 'r--', t, t**2, 'bs', t, t**3, 'g^')
plt.show()
︡e4e1ea26-ba9c-4dbb-9868-2bef06fef144︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7fd118429510>, <matplotlib.lines.Line2D object at 0x7fd118429650>, <matplotlib.lines.Line2D object at 0x7fd118429dd0>]\n"}︡{"file":{"filename":"ff81fd5a-6013-4608-9c73-d69c35c52038.svg","show":true,"text":null,"uuid":"7d59e7a4-0c75-44a4-bd16-80142219c357"},"once":false}︡{"done":true}
︠3e50aedb-13bf-4387-898e-1183d91adfc0s︠
#For instructor_________________________________
#Data for detecting missed points
xblue=[195,187,171,115,75,27];yblue=[28,84,140,252,308,364]
#figure=plt.plot(xblue,yblue,'bo',markersize=4)# Include into the plotting command code above

︡3f8f86b9-0c5a-4715-9044-552878b58bac︡{"done":true}
︠30b93bf3-d32d-44c8-b482-ac321325eff1s︠
#4 Find the missing point in the figure created in Part 3 (see directions in Chapter 2)
gcd(147,196)
︡b3063c15-6b49-4da3-b3a0-6c6ca813de71︡{"stdout":"49\n"}︡{"done":true}
︠c149c310-51e8-4cb8-9ad2-b4987b017050︠
#5 Write a brief summary (3-4 sentences). See directions in Chapter 2.
︠db102b61-bfa2-48cd-8ebf-7beeb0fd6662︠









